<html>
<head>
	<title>Easy Recursive CHMODder by drumrock v0.1</title>
</head>
<body>
<h1>Easy Recursive CHMODder by drumrock v0.1</h1>
<form action="<?=$_SERVER["PHP_SELF"]?>" method="post">
<table cellspacing="0" cellpadding="2" border="1">
<tbody>
<tr>
	<td>&nbsp;</td>
	<th>User</th>
	<th>Group</th>
	<th>Others</th>
</tr>
<tr>
	<th>Read</th>
	<td><input type="checkbox" name="user_r" checked="checked" /></td>
	<td><input type="checkbox" name="group_r" checked="checked" /></td>
	<td><input type="checkbox" name="others_r" checked="checked" /></td>
</tr>
<tr>
	<th>Write</th>
	<td><input type="checkbox" name="user_w" checked="checked" /></td>
	<td><input type="checkbox" name="group_w" /></td>
	<td><input type="checkbox" name="others_w" /></td>
</tr>
<tr>
	<th>Execute</th>
	<td><input type="checkbox" name="user_x" checked="checked" /></td>
	<td><input type="checkbox" name="group_x" checked="checked" /></td>
	<td><input type="checkbox" name="others_x" checked="checked" /></td>
</tr>
</tbody>
</table>
<input type='hidden' name='do_chmod' value='YES' />
<p><input type='submit' value='CHMOD' /></p>
<p><small>Note: CHMOD applies to both files and directories</small></p>
<p><a href="http://drumrock.skipitnow.org/">drumrock</a>, 2007</p>
</form>
<?php


function getVar($name) {
	return isset($_REQUEST[$name]) ? $_REQUEST[$name] : false;
}

$userPermissions = (getVar("user_r") ? 4 : 0) + (getVar("user_w") ? 2 : 0) + (getVar("user_x") ? 1 : 0);
$groupPermissions = (getVar("group_r") ? 4 : 0) + (getVar("group_w") ? 2 : 0) + (getVar("group_x") ? 1 : 0);
$othersPermissions = (getVar("others_r") ? 4 : 0) + (getVar("others_w") ? 2 : 0) + (getVar("others_x") ? 1 : 0);

$permissions = "0" . $userPermissions . $groupPermissions . $othersPermissions;



if(getVar("do_chmod") != "YES") {
	die();
}



function recursiveChmod($path, $permissions) {
	global $count, $failures;
	$dir = opendir($path);
	while($item = readdir($dir)) {
		if($item == "." || $item == "..") {
			continue;
		}
		$itemPath = $path . "/" . $item;
		//echo $itemPath;
		if(! chmod($itemPath, $permissions)) {
			echo "<p>CHMOD failed on: " . $itemPath . "</p>";
			$failures++;
		}
		$count++;
		if(is_dir($itemPath)) {
			recursiveChmod($itemPath, $permissions);
		}
	}
}


echo "<p>Applying permissions: " . $permissions . "...";
$count = 0;
$failures = 0;
$realPermissions = octdec($permissions);
recursiveChmod(".", $realPermissions);

echo " finished. " . $count . " items processed, " . $failures . " failed.";

?>
